      subroutine step3d_fast (tile)
      implicit none
      integer*4 tile, trd
      integer*4  LLm,Lm,MMm,Mm,N, LLm0,MMm0
      parameter (LLm0=128,  MMm0=1,   N=128)
      parameter (LLm=LLm0,  MMm=MMm0)
      integer*4 Lmmpi,Mmmpi,iminmpi,imaxmpi,jminmpi,jmaxmpi
      common /comm_setup_mpi1/ Lmmpi,Mmmpi
      common /comm_setup_mpi2/ iminmpi,imaxmpi,jminmpi,jmaxmpi
      integer*4 NSUB_X, NSUB_E, NPP
      parameter (NPP=1)
      parameter (NSUB_X=1, NSUB_E=NPP)
      integer*4 NWEIGHT
      parameter (NWEIGHT=1000)
      integer*4 stdout, Np, padd_X,padd_E
      parameter (stdout=6)
      parameter (Np=N+1)
      parameter (Lm=LLm, Mm=MMm)
      parameter (padd_X=(Lm+2)/2-(Lm+1)/2)
      parameter (padd_E=(Mm+2)/2-(Mm+1)/2)
      integer*4 NSA, N2d,N3d, size_XI,size_ETA
      integer*4 se,sse, sz,ssz
      parameter (NSA=35)
      parameter (size_XI=7+(Lm+NSUB_X-1)/NSUB_X)
      parameter (size_ETA=7+(Mm+NSUB_E-1)/NSUB_E)
      parameter (sse=size_ETA/Np, ssz=Np/size_ETA)
      parameter (se=sse/(sse+ssz), sz=1-se)
      parameter (N2d=size_XI*(se*size_ETA+sz*Np))
      parameter (N3d=size_XI*size_ETA*Np)
      real Vtransform
      parameter (Vtransform=2)
      integer*4   NT, itemp
      integer*4   ntrc_salt, ntrc_pas, ntrc_bio, ntrc_sed
      parameter (itemp=1)
      parameter (ntrc_salt=0)
      parameter (ntrc_pas=0)
      parameter (ntrc_bio=0)
      parameter (ntrc_sed=0)
      parameter (NT=itemp+ntrc_salt+ntrc_pas+ntrc_bio+ntrc_sed)
      integer*4   ntrc_diats, ntrc_diauv, ntrc_diabio
      integer*4   ntrc_diavrt, ntrc_diaek, ntrc_diapv
      integer*4   ntrc_diaeddy, ntrc_surf
      parameter (ntrc_diabio=0)
      parameter (ntrc_diats=0)
      parameter (ntrc_diauv=0)
      parameter (ntrc_diavrt=0)
      parameter (ntrc_diaek=0)
      parameter (ntrc_diapv=0)
      parameter (ntrc_diaeddy=0)
      parameter (ntrc_surf=0)
      real A2d(N2d,NSA,0:NPP-1), A3d(N3d,7,0:NPP-1)
      common/private_scratch/ A2d,A3d
C$    integer*4 omp_get_thread_num
      integer*4 chunk_size_X,margin_X,chunk_size_E,margin_E
      integer*4 Istr,Iend,Jstr,Jend, i_X,j_E
      chunk_size_X=(Lm+NSUB_X-1)/NSUB_X
      margin_X=(NSUB_X*chunk_size_X-Lm)/2
      chunk_size_E=(Mm+NSUB_E-1)/NSUB_E
      margin_E=(NSUB_E*chunk_size_E-Mm)/2
      j_E=tile/NSUB_X
      i_X=tile-j_E*NSUB_X
      Istr=1+i_X*chunk_size_X-margin_X
      Iend=Istr+chunk_size_X-1
      Istr=max(Istr,1)
      Iend=min(Iend,Lm)
      Jstr=1+j_E*chunk_size_E-margin_E
      Jend=Jstr+chunk_size_E-1
      Jstr=max(Jstr,1)
      Jend=min(Jend,Mm)
      trd=0
C$    trd=omp_get_thread_num()
      call step3d_fast_tile ( Istr,Iend,Jstr,Jend
     &                   , A2d(1, 1,trd), A2d(1, 2,trd), A2d(1, 3,trd)
     &                   , A2d(1, 4,trd), A2d(1, 5,trd), A2d(1, 6,trd)
     &                   , A2d(1, 7,trd), A2d(1, 8,trd)
     &                   , A2d(1, 9,trd), A2d(1,10,trd)
     &                   , A2d(1,11,trd), A2d(1,12,trd)
     &                   , A2d(1,13,trd), A2d(1,14,trd)
     &                   , A2d(1,15,trd), A2d(1,16,trd)
     &                   , A3d(1, 1,trd), A3d(1, 2,trd)
     &                   , A3d(1, 3,trd), A3d(1, 4,trd)
     &                   , A3d(1, 5,trd), A3d(1, 6,trd)
     &                   )
      return
      end
      subroutine step3d_fast_tile (Istr,Iend,Jstr,Jend
     &                          ,Dnew,rubar,rvbar
     &                          ,Drhs, UFx,UFe
     &                          ,VFx,VFe
     &                          ,urhs,vrhs
     &                          ,DUon,DVom
     &                          ,ru_ext_nbq_sum, rv_ext_nbq_sum
     &                          ,ru_ext_nbq_old, rv_ext_nbq_old
     &                          ,Hzw_half_nbq_inv,  Hzr_half_nbq_inv
     &                          ,Hzw_half_nbq_inv_u,Hzw_half_nbq_inv_v
     &                          ,Hzu_half_qdmu,     Hzv_half_qdmv
     &                          )
      implicit none
      integer*4  LLm,Lm,MMm,Mm,N, LLm0,MMm0
      parameter (LLm0=128,  MMm0=1,   N=128)
      parameter (LLm=LLm0,  MMm=MMm0)
      integer*4 Lmmpi,Mmmpi,iminmpi,imaxmpi,jminmpi,jmaxmpi
      common /comm_setup_mpi1/ Lmmpi,Mmmpi
      common /comm_setup_mpi2/ iminmpi,imaxmpi,jminmpi,jmaxmpi
      integer*4 NSUB_X, NSUB_E, NPP
      parameter (NPP=1)
      parameter (NSUB_X=1, NSUB_E=NPP)
      integer*4 NWEIGHT
      parameter (NWEIGHT=1000)
      integer*4 stdout, Np, padd_X,padd_E
      parameter (stdout=6)
      parameter (Np=N+1)
      parameter (Lm=LLm, Mm=MMm)
      parameter (padd_X=(Lm+2)/2-(Lm+1)/2)
      parameter (padd_E=(Mm+2)/2-(Mm+1)/2)
      integer*4 NSA, N2d,N3d, size_XI,size_ETA
      integer*4 se,sse, sz,ssz
      parameter (NSA=35)
      parameter (size_XI=7+(Lm+NSUB_X-1)/NSUB_X)
      parameter (size_ETA=7+(Mm+NSUB_E-1)/NSUB_E)
      parameter (sse=size_ETA/Np, ssz=Np/size_ETA)
      parameter (se=sse/(sse+ssz), sz=1-se)
      parameter (N2d=size_XI*(se*size_ETA+sz*Np))
      parameter (N3d=size_XI*size_ETA*Np)
      real Vtransform
      parameter (Vtransform=2)
      integer*4   NT, itemp
      integer*4   ntrc_salt, ntrc_pas, ntrc_bio, ntrc_sed
      parameter (itemp=1)
      parameter (ntrc_salt=0)
      parameter (ntrc_pas=0)
      parameter (ntrc_bio=0)
      parameter (ntrc_sed=0)
      parameter (NT=itemp+ntrc_salt+ntrc_pas+ntrc_bio+ntrc_sed)
      integer*4   ntrc_diats, ntrc_diauv, ntrc_diabio
      integer*4   ntrc_diavrt, ntrc_diaek, ntrc_diapv
      integer*4   ntrc_diaeddy, ntrc_surf
      parameter (ntrc_diabio=0)
      parameter (ntrc_diats=0)
      parameter (ntrc_diauv=0)
      parameter (ntrc_diavrt=0)
      parameter (ntrc_diaek=0)
      parameter (ntrc_diapv=0)
      parameter (ntrc_diaeddy=0)
      parameter (ntrc_surf=0)
      integer*4 Istr,Iend,Jstr,Jend, i,j,k, kbak,kold,
     &        imin,imax,jmin,jmax,
     &        k1, k2, kp1
      real    mybeta,myalpha,myepsilon,mygamma,
     &        VMAX,VMAXL, cff,cff0,cff1,cff2,cff3,
     &        DUnew,DVnew, dum_s
      real,parameter :: thetaimp_nbq = 1.D0
      real,parameter :: gammau=0.45D0
      real,parameter :: gammau_2=(1.D0/3.D0)*(1.D0-gammau)
      real
     &                Dnew(Istr-2:Iend+2,Jstr-2:Jend+2),
     &               rubar(Istr-2:Iend+2,Jstr-2:Jend+2),
     &               rvbar(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                Drhs(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                 UFx(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                 UFe(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                 VFx(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                 VFe(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                urhs(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                vrhs(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                DUon(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                DVom(Istr-2:Iend+2,Jstr-2:Jend+2)
      real
     &       ru_ext_nbq_sum(Istr-2:Iend+2,Jstr-2:Jend+2),
     &       rv_ext_nbq_sum(Istr-2:Iend+2,Jstr-2:Jend+2),
     &       ru_ext_nbq_old(Istr-2:Iend+2,Jstr-2:Jend+2),
     &       rv_ext_nbq_old(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                 work(Istr-2:Iend+2,Jstr-2:Jend+2)
      real    Hzu_half_qdmu(Istr-2:Iend+2,Jstr-2:Jend+2,0:N),
     &        Hzv_half_qdmv(Istr-2:Iend+2,Jstr-2:Jend+2,0:N),
     &     Hzw_half_nbq_inv(Istr-2:Iend+2,Jstr-2:Jend+2,0:N),
     &     Hzr_half_nbq_inv(Istr-2:Iend+2,Jstr-2:Jend+2,  N),
     &   Hzw_half_nbq_inv_u(Istr-2:Iend+2,Jstr-2:Jend+2,0:N),
     &   Hzw_half_nbq_inv_v(Istr-2:Iend+2,Jstr-2:Jend+2,0:N)
      real
     &    dthetadiv_nbqdz_u(Istr-2:Iend+2,Jstr-2:Jend+2,2),
     &    dthetadiv_nbqdz_v(Istr-2:Iend+2,Jstr-2:Jend+2,2),
     &    dthetadiv_nbqdz_w(Istr-2:Iend+2,Jstr-2:Jend+2,2),
     &              dZdxq_u(Istr-2:Iend+2,Jstr-2:Jend+2,2),
     &              dZdyq_v(Istr-2:Iend+2,Jstr-2:Jend+2,2),
     &                   FX(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                   FY(Istr-2:Iend+2,Jstr-2:Jend+2),
     &                   FC(Istr-2:Iend+2,0:N),
     &                   DC(Istr-2:Iend+2,0:N),
     &                   CF(Istr-2:Iend+2,0:N),
     &         qdmw_nbq_old(Istr-2:Iend+2,Jstr-2:Jend+2,0:N)
      real h(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real hinv(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real f(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real fomn(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /grid_h/h /grid_hinv/hinv /grid_f/f /grid_fomn/fomn
      real xp(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real xr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real yp(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real yr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /grid_xr/xr /grid_xp/xp /grid_yp/yp /grid_yr/yr
      real pm(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pn(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real om_r(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real on_r(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real om_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real on_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real om_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real on_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real om_p(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real on_p(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pn_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pm_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pm_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pn_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /metrics_pm/pm    /metrics_pn/pn
      common /metrics_omr/om_r /metrics_on_r/on_r
      common /metrics_omu/om_u /metrics_on_u/on_u
      common /metrics_omv/om_v /metrics_on_v/on_v
      common /metrics_omp/om_p /metrics_on_p/on_p
      common /metrics_pnu/pn_u /metrics_pmv/pm_v
      common /metrics_pmu/pm_u /metrics_pnv/pn_v
      real pmon_p(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pmon_r(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pmon_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pnom_p(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pnom_r(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pnom_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real grdscl(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /metrics_pmon_p/pmon_p /metrics_pnom_p/pnom_p
      common /metrics_pmon_r/pmon_r /metrics_pnom_r/pnom_r
      common /metrics_pmon_u/pmon_u /metrics_pnom_v/pnom_v
      common /metrics_grdscl/grdscl
      real zob(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /Z0B_VAR/zob
      real zeta(-2:Lm+3+padd_X,0:Mm+1+padd_E,4)
      real ubar(-2:Lm+3+padd_X,0:Mm+1+padd_E,4)
      real vbar(-2:Lm+3+padd_X,0:Mm+1+padd_E,4)
      common /ocean_zeta/zeta
      common /ocean_ubar/ubar
      common /ocean_vbar/vbar
      real u(-2:Lm+3+padd_X,0:Mm+1+padd_E,N,3)
      real v(-2:Lm+3+padd_X,0:Mm+1+padd_E,N,3)
      real t(-2:Lm+3+padd_X,0:Mm+1+padd_E,N,3,NT)
      common /ocean_u/u /ocean_v/v /ocean_t/t
      real Hz(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real Hz_bak(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real z_r(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real z_w(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      real Huon(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real Hvom(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /grid_Hz_bak/Hz_bak /grid_zw/z_w /grid_Huon/Huon
      common /grid_Hvom/Hvom
      real We(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /grid_Hz/Hz /grid_zr/z_r /grid_We/We
      real wz(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N,3)
      common /ocean_wz/wz
      real rho1(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real rho(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /ocean_rho1/rho1 /ocean_rho/rho
      real rhoA(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real rhoS(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /coup_rhoA/rhoA           /coup_rhoS/rhoS
      real rufrc(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real rvfrc(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real rufrc_bak(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      real rvfrc_bak(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      common /coup_rufrc/rufrc
      common /coup_rvfrc/rvfrc
      common /coup_rufrc_bak/rufrc_bak
      common /coup_rvfrc_bak/rvfrc_bak
      real Zt_avg1(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real DU_avg1(-2:Lm+3+padd_X,0:Mm+1+padd_E,5)
      real DV_avg1(-2:Lm+3+padd_X,0:Mm+1+padd_E,5)
      real DU_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real DV_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /ocean_Zt_avg1/Zt_avg1
      common /coup_DU_avg1/DU_avg1
      common /coup_DV_avg1/DV_avg1
      common /coup_DU_avg2/DU_avg2
      common /coup_DV_avg2/DV_avg2
      real sustr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real svstr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /forces_sustr/sustr /forces_svstr/svstr
      real bustr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real bvstr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /forces_bustr/bustr /forces_bvstr/bvstr
      real bustrg(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      real bvstrg(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      common /bmsdat_bustrg/bustrg /bmsdat_bvstrg/bvstrg
      real bms_tintrp(2), bustrp(2),    bvstrp(2), tbms(2)
      real bmsclen, bms_tstart, bms_tend,  tsbms, sclbms
      integer*4 itbms,      bmstid,busid, bvsid,     tbmsindx
      logical bmscycle,   bms_onerec,   lbusgrd,   lbvsgrd
      common /bmsdat1/bms_tintrp, bustrp,       bvstrp,    tbms
      common /bmsdat2/bmsclen, bms_tstart, bms_tend, tsbms, sclbms
      common /bmsdat3/itbms,      bmstid,busid, bvsid,     tbmsindx
      common /bmsdat4/bmscycle,   bms_onerec,   lbusgrd,   lbvsgrd
      real stflx(-2:Lm+3+padd_X,0:Mm+1+padd_E,NT)
      common /forces_stflx/stflx
      real btflx(-2:Lm+3+padd_X,0:Mm+1+padd_E,NT)
      common /forces_btflx/btflx
      real srflx(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /forces_srflx/srflx
      real srflxg(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      common /srfdat_srflxg/srflxg
      real srflxp(2),srf_time(2)
      real srf_cycle, srf_scale
      integer*4 itsrf, srf_ncycle, srf_rec
      integer*4 lsrfgrd, srf_tid, srf_id
      common /srfdat1/ srflxp, srf_time, srf_cycle, srf_scale
      common /srfdat2/ itsrf,srf_ncycle,srf_rec,lsrfgrd,srf_tid,srf_id
      real Akv(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      real Akt(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N,2)
      common /mixing_Akv/Akv /mixing_Akt/Akt
      real dt, dtfast, time, time2, time_start, tdays
      integer*4 ndtfast, iic, kstp, krhs, knew, next_kstp
     &      , iif, nstp, nrhs, nnew, nbstep3d
      logical PREDICTOR_2D_STEP
      common /time_indices/  dt,dtfast, time, time2,time_start, tdays,
     &                       ndtfast, iic, kstp, krhs, knew, next_kstp,
     &                       iif, nstp, nrhs, nnew, nbstep3d,
     &                       PREDICTOR_2D_STEP
      real time_avg, time2_avg, rho0
     &               , rdrg, rdrg2, Cdb_min, Cdb_max, Zobt
     &               , xl, el, visc2, visc4, gamma2
      real  theta_s,   theta_b,   Tcline,  hc
      real  sc_w(0:N), Cs_w(0:N), sc_r(N), Cs_r(N)
      real  rx0, rx1
      real  tnu2(NT),tnu4(NT)
      real R0,T0,S0, Tcoef, Scoef
      real weight(6,0:NWEIGHT)
      integer*4 numthreads,     ntstart,   ntimes,  ninfo
     &      , nfast,  nrrec,     nrst,    nwrt
      logical ldefhis
      logical got_tini(NT)
      common /scalars_main/
     &             time_avg, time2_avg,  rho0,      rdrg,    rdrg2
     &           , Zobt,       Cdb_min,   Cdb_max
     &           , xl, el,    visc2,     visc4,   gamma2
     &           , theta_s,   theta_b,   Tcline,  hc
     &           , sc_w,      Cs_w,      sc_r,    Cs_r
     &           , rx0,       rx1,       tnu2,    tnu4
     &                      , R0,T0,S0,  Tcoef,   Scoef
     &                      , weight
     &      , numthreads,     ntstart,   ntimes,  ninfo
     &      , nfast,  nrrec,     nrst,    nwrt
     &                      , got_tini
     &                      , ldefhis
      real Akv_bak
      real Akt_bak(NT)
      common /scalars_akt/ Akv_bak, Akt_bak
      logical synchro_flag
      common /sync_flag/ synchro_flag
      integer*4 may_day_flag
      integer*4 tile_count, first_time, bc_count
      common /communicators_i/
     &        may_day_flag, tile_count, first_time, bc_count
      real hmin, hmax, grdmin, grdmax, Cu_min, Cu_max
      common /communicators_r/
     &     hmin, hmax, grdmin, grdmax, Cu_min, Cu_max
      real*8 Cu_Adv3d,  Cu_W, Cu_Nbq_X, Cu_Nbq_Y, Cu_Nbq_Z
      integer*4 i_cx_max, j_cx_max, k_cx_max
      common /diag_vars/ Cu_Adv3d,  Cu_W,
     &        i_cx_max, j_cx_max, k_cx_max
      real*8 volume, avgke, avgpe, avgkp, bc_crss
     &        , avg_vol, avg_rho
      common /communicators_rq/
     &          volume, avgke, avgpe, avgkp, bc_crss
     &        , avg_vol, avg_rho
      real*4 CPU_time(0:31,0:NPP)
      integer*4 proc(0:31,0:NPP),trd_count
      common /timers_roms/CPU_time,proc,trd_count
      real pi, deg2rad, rad2deg
      parameter (pi=3.14159265358979323846D0, deg2rad=pi/180.D0,
     &                                      rad2deg=180.D0/pi)
      real Eradius, Erotation, g, day2sec,sec2day, jul_off,
     &     year2day,day2year
      parameter (Eradius=6371315.0D0,  Erotation=7.292115090D-5,
     &           day2sec=86400.D0, sec2day=1.D0/86400.D0,
     &           year2day=365.25D0, day2year=1.D0/365.25D0,
     &           jul_off=2440000.D0)
      parameter (g=9.81D0)
      real Cp
      parameter (Cp=3985.0D0)
      real vonKar
      parameter (vonKar=0.41D0)
      real spval
      parameter (spval=0.0D0)
      logical mask_val
      parameter (mask_val = .true.)
      logical M2bc_nbq_flag
      common /nbq_M2bc/ M2bc_nbq_flag
      integer*4 iteration_nbq_max
      common /nbq_var1/ iteration_nbq_max
      integer*4 iteration_nbq
      common /nbq_var2/ iteration_nbq
      integer*4 ifl_nbq
      common /nbq_var3/ ifl_nbq
      integer*4 slip_nbq
      common /nbq_var4/ slip_nbq
      real soundspeed_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_param1/ soundspeed_nbq
      real soundspeed2_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_param2/ soundspeed2_nbq
      double precision time_nbq
      common /nbq_param3/ time_nbq
      double precision csvisc1_nbq
      common /nbq_param4/ csvisc1_nbq
      double precision csvisc2_nbq
      common /nbq_param5/ csvisc2_nbq
      double precision cw_int_nbq
      common /nbq_param6/ cw_int_nbq
      double precision ifl_imp_nbq
      common /nbq_param7/ ifl_imp_nbq
      integer*4 ndtnbq
      common /time_nbq1/ ndtnbq
      real dtnbq
      common /time_nbq2/ dtnbq
      real csound_nbq
      common /nbq_csound/ csound_nbq
      real visc2_nbq
      common /nbq_visc2/ visc2_nbq
      real dtgrid_nbq
      common /nbq_dtgrid/ dtgrid_nbq
      real qdmu_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_qdmu_nbq/ qdmu_nbq
      real qdmv_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_qdmv_nbq/ qdmv_nbq
      real qdmw_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /nbq_qdmw_nbq/ qdmw_nbq
      real thetadiv_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_thetadiv_nbq/ thetadiv_nbq
      real thetadiv2_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_thetadiv2_nbq/ thetadiv2_nbq
      real thetadiv3_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_thetadiv3_nbq/ thetadiv3_nbq
      real ru_int_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_ruint/ ru_int_nbq
      real rv_int_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_rvint/ rv_int_nbq
      real ru_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_ru/ ru_nbq
      real rv_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_rv/ rv_nbq
      real ru_nbq_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /avg2_runbq/ ru_nbq_avg2
      real rv_nbq_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /avg2_rvnbq/ rv_nbq_avg2
      real rw_int_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /nbq_rwint/ rw_int_nbq
      real rw_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /nbq_rw/ rw_nbq
      real rw_nbq_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /avg2_rwnbq/ rw_nbq_avg2
      real rho_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common/nbq_rho_nbq/rho_nbq
      integer*4 inc_faststep
      common/nbq_inc_faststep/inc_faststep
      integer*4 nb_faststep
      common/nbq_nb_faststep/nb_faststep
      real DU_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_DU_nbq/ DU_nbq
      real DV_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_DV_nbq/ DV_nbq
      real ru_int_nbq_2d (-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_ruint_2d/ru_int_nbq_2d
      real rv_int_nbq_2d (-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_rvint_2d/rv_int_nbq_2d
      real rho_grd(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common/nbq_rho_grd/rho_grd
      real rho_bak(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common/nbq_rho_bak/rho_bak
      real Hzw_half_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /grid_Hzw_half_nbq/ Hzw_half_nbq
      real zw_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N,4)
      common /nbq_zw/ zw_nbq
       real Hz_correct(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
       common /grid_Hz_correct/ Hz_correct
      real dthetadiv_nbqdz(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N,2)
      common /nbq_nods3/ dthetadiv_nbqdz
      real dZdxq_w(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N+1)
      common /nbq_nods5/ dZdxq_w
      real dZdyq_w(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N+1)
      common /nbq_nods7/ dZdyq_w
      real wsurf_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_wsurf/ wsurf_nbq
      real usurf_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_usurf/ usurf_nbq
      real vsurf_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_vsurf/ vsurf_nbq
      integer*4 IstrR,IendR,JstrR,JendR
      integer*4 JstrV
      if (istr.eq.1) then
        IstrR=Istr-2
      else
        IstrR=Istr
      endif
      if (iend.eq.Lm) then
        IendR=Iend+2
      else
        IendR=Iend
      endif
      if (jstr.eq.1) then
        JstrR=Jstr-1
        JstrV=Jstr+1
      else
        JstrR=Jstr
        JstrV=Jstr
      endif
      if (jend.eq.Mm) then
        JendR=Jend+1
      else
        JendR=Jend
      endif
      if (iic.eq.ntstart.and.iif.eq.1) then
         do k=1,N
           do j=JstrV-2,Jend+1
             do i=Istr-2,Iend+1
               rho_bak(i,j,k)=rho(i,j,k)
             enddo
            enddo
          enddo
      endif
      do j=JstrR,JendR
          do k=1,N
            do i=IstrR,IendR
              rho_grd(i,j,k)=(rho(i,j,k)*1.5D0-rho_bak(i,j,k)*0.5D0)
     &                                                             /rho0
            enddo
          enddo
      enddo
      mybeta=0.281105D0
       if (iif.eq.1) then
        kbak=kstp
        kold=kstp
        cff1= 1.0D0
        cff2= 0.0D0
        cff3= 0.0D0
       elseif (iif.eq.1+1) then
        kbak=kstp-1
        if (kbak.lt.1) kbak=4
        kold=kbak
        cff1= 1.5D0
        cff2=-0.5D0
        cff3= 0.0D0
      else
        kbak=kstp-1
        if (kbak.lt.1) kbak=4
        kold=kbak-1
        if (kold.lt.1) kold=4
        cff1= 1.5D0+mybeta
        cff2=-2.0D0*mybeta-0.5D0
        cff3= mybeta
      endif
      do j=JstrV-2,Jend+1
        do i=Istr-2,Iend+1
          Drhs(i,j)=cff1*(zeta(i,j,kstp )+h(i,j))
     &             +cff2*(zeta(i,j,kbak)+h(i,j))
     &             +cff3*(zeta(i,j,kold)+h(i,j))
        enddo
      enddo
      do j=Jstr-1,Jend+1
        do i=Istr-1,Iend+1
          urhs(i,j)=cff1*ubar(i,j,kstp)
     &             +cff2*ubar(i,j,kbak)
     &             +cff3*ubar(i,j,kold)
          DUon(i,j)=0.5D0*(Drhs(i,j)+Drhs(i-1,j))*on_u(i,j)*( urhs(i,j)
     &                                                              )
        enddo
      enddo
      do j=JstrV-1,Jend+1
        do i=Istr-1,Iend+1
          vrhs(i,j)=cff1*vbar(i,j,kstp)
     &             +cff2*vbar(i,j,kbak)
     &             +cff3*vbar(i,j,kold)
          DVom(i,j)=0.5D0*(Drhs(i,j)+Drhs(i,j-1))*om_v(i,j)*( vrhs(i,j)
     &                                                              )
        enddo
      enddo
      if (iif.eq.1) then
        call grid_nbq_tile(Istr,Iend,Jstr,Jend,
     &                     Hzw_half_nbq_inv,   Hzr_half_nbq_inv,
     &                     Hzw_half_nbq_inv_u, Hzw_half_nbq_inv_v,
     &                     Hzu_half_qdmu,      Hzv_half_qdmv)
      endif
      if (Istr.le.Iend) then
        do j=Jstr,Jend
          do i=Istr-1,Iend+1
            usurf_nbq(i,j)=(qdmu_nbq(i,j,N)
     &                     *2.D0/(Hz(i,j,N)+Hz(i-1,j,N))
     &                     )
          enddo
        enddo
      endif
      if (JstrV.le.Jend) then
        do j=JstrV-1,Jend+1
          do i=Istr,Iend
            vsurf_nbq(i,j)=(qdmv_nbq(i,j,N)
     &                     *2.D0/(Hz(i,j,N)+Hz(i,j-1,N))
     &                      )
          enddo
        enddo
      endif
      do j=JstrV-1,Jend
        do i=Istr-1,Iend
          wsurf_nbq(i,j)=(qdmw_nbq(i,j,N)
     &                       *Hzw_half_nbq_inv(i,j,N)
     &                    )
        enddo
      enddo
      if (Istr.le.Iend) then
        call exchange_u2d_tile (Istr,Iend,Jstr,Jend,
     &                          usurf_nbq(-2,0))
      endif
      if (JstrV.le.Jend) then
        call exchange_v2d_tile (Istr,Iend,Jstr,Jend,
     &                          vsurf_nbq(-2,0))
      endif
      call exchange_r2d_tile (Istr,Iend,Jstr,Jend,
     &                        wsurf_nbq(-2,0))
      if (iif.eq.1) then
        cff1 = 1.0D0
        cff2 = 0.0D0
        cff3 = 0.0D0
      elseif (iif.eq.1+1) then
        cff1 = 1.5D0
        cff2 =-0.5D0
        cff3 = 0.0D0
      else
        cff1 = 1.5D0+mybeta
        cff2 =-2.0D0*mybeta-0.5D0
        cff3 = mybeta
      endif
      do j=JstrV-2,Jend+1
        do i=Istr-2,Iend+1
          UFx(i,j) =   cff1 * zeta(i,j,kstp)
     &                + cff2 * zeta(i,j,kbak)
     &                + cff3 * zeta(i,j,kold)
        enddo
      enddo
      do j=JstrV-1,Jend
        do i=Istr-1,Iend
          zeta(i,j,knew)=(zeta(i,j,kstp) + dtfast*( wsurf_nbq(i,j)
     &                     -0.5D0*(usurf_nbq(i  ,j)
     &                                     *(UFx(i  ,j)
     &                                      -UFx(i-1,j))*pm_u(i,j)
     &                          +usurf_nbq(i+1,j)
     &                                     *(UFx(i+1,j)
     &                                      -UFx(i  ,j))*pm_u(i+1,j)
     &                          )
     &                     -0.5D0*(vsurf_nbq(i  ,j)
     &                                     *(UFx(i,j  )
     &                                      -UFx(i,j-1))*pn_v(i,j)
     &                          +vsurf_nbq(i,j+1)
     &                                     *(UFx(i,j+1)
     &                                      -UFx(i,j  ))*pn_v(i,j+1)
     &                          )
     &                                                ) )
        enddo
      enddo
      call zetabc_tile (Istr,Iend,Jstr,Jend)
      call exchange_r2d_tile (Istr,Iend,Jstr,Jend,
     &                        zeta(-2,0,knew))
      myalpha   = 0.25D0
      myepsilon = 0.00976186D0 - 0.13451357D0*myalpha
      mygamma   = 0.08344500D0 - 0.51358400D0*myalpha
      if (iif.eq.1) then
        cff0=0.D0
        cff1=1.D0
        cff2=0.D0
        cff3=0.D0
      elseif (iif.eq.1+1) then
        cff0= 1.0833333333333D0
        cff1=-0.1666666666666D0
        cff2= 0.0833333333333D0
        cff3= 0.D0
      else
        cff0=0.5D0+2.D0*myepsilon+mygamma+2.D0*myalpha
        cff1=1.D0-cff0-mygamma-myepsilon
        cff2=mygamma
        cff3=myepsilon
      endif
      do j=JstrV-1,Jend
        do i=Istr-1,Iend
          UFx(i,j)=cff0*zeta(i,j,knew)+cff1*zeta(i,j,kstp)
     &             +cff2*zeta(i,j,kbak)+cff3*zeta(i,j,kold)
          UFe(i,j)=(1.D0+rhoS(i,j))*UFx(i,j)
          VFe(i,j)=UFe(i,j)*UFx(i,j)
          VFx(i,j)=UFx(i,j)*(rhoS(i,j)-rhoA(i,j))
        enddo
      enddo
      cff=0.5D0*g
      do j=Jstr,Jend
        do i=Istr,Iend
          rubar(i,j)=cff*on_u(i,j)*( (h(i-1,j)+h(i,j))*(UFe(i-1,j)
     &                        -UFe(i,j)) +VFe(i-1,j)-VFe(i,j)
     &              +(h(i-1,j)-h(i,j))*( VFx(i-1,j)+VFx(i,j)
     &                        +0.333333333333D0*(rhoA(i-1,j)-rhoA(i,j))
     &                                      *(UFx(i-1,j)-UFx(i,j)))
     &                                                              )
          rvbar(i,j)=cff*om_v(i,j)*( (h(i,j-1)+h(i,j))*(UFe(i,j-1)
     &                        -UFe(i,j)) +VFe(i,j-1)-VFe(i,j)
     &              +(h(i,j-1)-h(i,j))*( VFx(i,j-1)+VFx(i,j)
     &                        +0.333333333333D0*(rhoA(i,j-1)-rhoA(i,j))
     &                                      *(UFx(i,j-1)-UFx(i,j)))
     &                                                              )
        enddo
      enddo
      do j=Jstr,Jend
        do i=Istr-1,Iend
          UFx(i,j)=0.25D0*(DUon(i,j)+DUon(i+1,j))
     &                 *(urhs(i,j)+urhs(i+1,j))
          VFx(i+1,j)=0.25D0*(DUon(i+1,j)+DUon(i+1,j-1))
     &                   *(vrhs(i+1,j)+vrhs(i,j))
        enddo
      enddo
      do j=Jstr-1,Jend
        do i=Istr,Iend
          VFe(i,j)=0.25D0*(DVom(i,j)+DVom(i,j+1))
     &                 *(vrhs(i,j)+vrhs(i,j+1))
          UFe(i,j+1)=0.25D0*(DVom(i,j+1)+DVom(i-1,j+1))
     &                   *(urhs(i,j+1)+urhs(i,j))
        enddo
      enddo
      do j=Jstr,Jend
        do i=Istr,Iend
          rubar(i,j)=rubar(i,j)-UFx(i,j)+UFx(i-1,j)
     &                         -UFe(i,j+1)+UFe(i,j)
          rvbar(i,j)=rvbar(i,j)-VFx(i+1,j)+VFx(i,j)
     &                         -VFe(i,j)+VFe(i,j-1)
        enddo
      enddo
      if (rdrg2.gt.0.D0) then
        do j=Jstr,Jend
          do i=Istr,Iend
            cff=0.25D0*( vbar(i  ,j,kstp)+vbar(i  ,j+1,kstp)
     &                +vbar(i-1,j,kstp)+vbar(i-1,j+1,kstp))
            rubar(i,j)=rubar(i,j) - ubar(i,j,kstp)*( rdrg+rdrg2
     &              *sqrt(ubar(i,j,kstp)*ubar(i,j,kstp)+cff*cff)
     &                               )*om_u(i,j)*on_u(i,j)
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            cff=0.25D0*( ubar(i,j  ,kstp)+ubar(i+1,j  ,kstp)
     &                +ubar(i,j-1,kstp)+ubar(i+1,j-1,kstp))
            rvbar(i,j)=rvbar(i,j) - vbar(i,j,kstp)*( rdrg+rdrg2
     &              *sqrt(cff*cff+vbar(i,j,kstp)*vbar(i,j,kstp))
     &                               )*om_v(i,j)*on_v(i,j)
          enddo
        enddo
      else if (rdrg.gt.0.0D0) then
        do j=Jstr,Jend
          do i=Istr,Iend
            rubar(i,j)=rubar(i,j) - rdrg*ubar(i,j,kstp)
     &                             *om_u(i,j)*on_u(i,j)
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            rvbar(i,j)=rvbar(i,j) - rdrg*vbar(i,j,kstp)
     &                             *om_v(i,j)*on_v(i,j)
          enddo
        enddo
      endif
      if (iif.eq.1) then
        if (iic.eq.ntstart) then
          cff3=0.D0
          cff2=0.D0
          cff1=1.D0
        elseif (iic.eq.ntstart+1) then
          cff3= 0.D0
          cff2=-0.5D0
          cff1= 1.5D0
        else
          cff3= 0.281105D0
          cff2=-0.5D0-2.D0*cff3
          cff1= 1.5D0+cff3
        endif
        do j=Jstr,Jend
         do i=Istr,Iend
           cff=rufrc(i,j)-rubar(i,j)
           rufrc(i,j)=cff1*cff + cff2*rufrc_bak(i,j,3-nstp)
     &                         + cff3*rufrc_bak(i,j,nstp)
           rufrc_bak(i,j,nstp)=cff
         enddo
        enddo
        do j=JstrV,Jend
         do i=Istr,Iend
           cff=rvfrc(i,j)-rvbar(i,j)
           rvfrc(i,j)=cff1*cff + cff2*rvfrc_bak(i,j,3-nstp)
     &                         + cff3*rvfrc_bak(i,j,nstp)
           rvfrc_bak(i,j,nstp)=cff
         enddo
        enddo
      endif
      if (iif.eq.1) then
        do j=Jstr,Jend
          do i=Istr,Iend
            ru_ext_nbq_sum(i,j)=0.D0
            ru_ext_nbq_old(i,j)=0.D0
          enddo
        enddo
        do j=JstrV,Jend
          do i=Istr,Iend
            rv_ext_nbq_sum(i,j)=0.D0
            rv_ext_nbq_old(i,j)=0.D0
          enddo
        enddo
      endif
      do j=Jstr,Jend
        do i=Istr,Iend
          UFx(i,j)=(rufrc(i,j)+rubar(i,j))
     &                                   *pm_u(i,j)*pn_u(i,j)
     &                                  /(Drhs(i,j)+Drhs(i-1,j))
          ru_ext_nbq_old(i,j)=UFx(i,j)-ru_ext_nbq_old(i,j)
          ru_ext_nbq_sum(i,j)=ru_ext_nbq_sum(i,j)+UFx(i,j)
        enddo
      enddo
      do k=1,N
        do j=Jstr,Jend
          do i=Istr,Iend
            ru_int_nbq(i,j,k)=ru_int_nbq(i,j,k)+
     &                        ru_ext_nbq_old(i,j)
     &                        *(Hz(i-1,j,k)+Hz(i,j,k))
          enddo
        enddo
      enddo
      do j=Jstr,Jend
        do i=Istr,Iend
          ru_ext_nbq_old(i,j)=UFx(i,j)
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          UFx(i,j)=(rvfrc(i,j)+rvbar(i,j))
     &                                   *pm_v(i,j)*pn_v(i,j)
     &                                   /(Drhs(i,j)+Drhs(i,j-1))
          rv_ext_nbq_old(i,j)=UFx(i,j)-rv_ext_nbq_old(i,j)
          rv_ext_nbq_sum(i,j)=rv_ext_nbq_sum(i,j)+UFx(i,j)
        enddo
      enddo
      do k=1,N
        do j=JstrV,Jend
          do i=Istr,Iend
            rv_int_nbq(i,j,k)=rv_int_nbq(i,j,k)+
     &                        rv_ext_nbq_old(i,j)
     &                        *(Hz(i,j-1,k)+Hz(i,j,k))
          enddo
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          rv_ext_nbq_old(i,j)=UFx(i,j)
        enddo
      enddo
      call exchange_u3d_tile (Istr,Iend,Jstr,Jend,
     &                        ru_int_nbq(-2,0,1))
      call exchange_v3d_tile (Istr,Iend,Jstr,Jend,
     &                        rv_int_nbq(-2,0,1))
      if (iif.eq.1) then
        do k=1,N
          do j=Jstr,Jend
            do i=Istr,Iend
              ru_nbq_avg2(i,j,k)=qdmu_nbq(i,j,k)
            enddo
          enddo
        enddo
        do k=1,N
          do j=JstrV,Jend
            do i=Istr,Iend
              rv_nbq_avg2(i,j,k)=qdmv_nbq(i,j,k)
            enddo
          enddo
        enddo
        do k=0,N
          do j=Jstr,Jend
            do i=Istr,Iend
              rw_nbq_avg2(i,j,k)=qdmw_nbq(i,j,k)
            enddo
          enddo
        enddo
      endif
      if (iic.eq.ntstart .and. iif.eq.1) then
        do j=JstrR,JendR
          do k=0,N
            do i=IstrR,IendR
              zw_nbq (i,j,k,:)=z_w(i,j,k)
            enddo
          enddo
        enddo
      endif
      do j=Jstr,Jend
        do i=Istr,Iend
          work(i,j)=pm(i,j)*pn(i,j)
          DU_nbq(i,j)=0.D0
          DV_nbq(i,j)=0.D0
        enddo
      enddo
      if (iif.eq.nfast) then
        do k=0,N
          do j=Jstr,Jend
            do i=Istr,Iend
               rw_nbq(i,j,k)=qdmw_nbq(i,j,k)
            enddo
          enddo
        enddo
      endif
      if (iic.gt.ntstart .and. iif.eq.1) then
        do k=1,N
          do j=JstrV-2,Jend+1
            do i=Istr-2,Iend+1
              Hz(i,j,k) = Hz_correct(i,j,k)
            enddo
          enddo
        enddo
      endif
      do k=1,N
        do j=JstrV-2,Jend+1
          do i=Istr-2,Iend+1
            thetadiv_nbq(i,j,k)=( -visc2_nbq*( thetadiv_nbq(i,j,k)
     &                                       +thetadiv3_nbq(i,j,k))
     &                         +soundspeed2_nbq(i,j)*rho_nbq(i,j,k) )
     &                                     *Hzr_half_nbq_inv(i,j,k)
          enddo
        enddo
      enddo
      k2 = 1
      do k=0,N
        k1=k2
        k2=3-k1
        if (mod(iic,1).eq.1 .and. iif.eq.1) then
          if (k.eq.0) then
            do j=Jstr,Jend
              do i=Istr-1,Iend
                dthetadiv_nbqdz_u(i,j,k2)=0.D0
              enddo
            enddo
            do j=Jstr-1,Jend
              do i=Istr,Iend
                dthetadiv_nbqdz_v(i,j,k2)=0.D0
              enddo
            enddo
          else
            if (k.eq.N) then
              do j=Jstr-1,Jend
                do i=Istr-1,Iend
                  dthetadiv_nbqdz(i,j,k,1)= - thetadiv_nbq(i,j,k)
                enddo
              enddo
            else
              do j=Jstr-1,Jend
                do i=Istr-1,Iend
                  dthetadiv_nbqdz(i,j,k,1)=thetadiv_nbq(i,j,k+1)
     &                                   - thetadiv_nbq(i,j,k)
                enddo
              enddo
            endif
            do j=Jstr,Jend
              do i=Istr,Iend
                dthetadiv_nbqdz_u(i,j,k2)=Hzw_half_nbq_inv_u(i,j,k)*(
     &                                    dthetadiv_nbqdz(i,j,k,1)
     &                                   +dthetadiv_nbqdz(i-1,j,k,1))
              enddo
            enddo
            do j=Jstr,Jend
              do i=Istr,Iend
                 dthetadiv_nbqdz_v(i,j,k2)=Hzw_half_nbq_inv_v(i,j,k)*(
     &                                     dthetadiv_nbqdz(i,j,k,1)
     &                                    +dthetadiv_nbqdz(i,j-1,k,1))
              enddo
            enddo
          endif
        endif
        if (k.gt.0) then
          do j=Jstr,Jend
            do i=Istr,Iend
              if (k.gt.1.and.k.lt.N) then
                if (mod(iic,1).eq.1 .and. iif.eq.1) then
                  dthetadiv_nbqdz(i,j,k,1)=(z_r(i  ,j,k)
     &                                     -z_r(i-1,j,k))
     &              *(dthetadiv_nbqdz_u(i,j,k2)+
     &                dthetadiv_nbqdz_u(i,j,k1))
                endif
                dum_s=dthetadiv_nbqdz(i,j,k,1)
              elseif (k.gt.1) then
                if (mod(iic,1).eq.1 .and. iif.eq.1) then
                  dthetadiv_nbqdz(i,j,k,1)=(z_r(i ,j,k)
     &                                     -z_r(i-1,j,k))
     &                 *dthetadiv_nbqdz_u(i,j,k1)
     &                 +(z_w(i,j,N)-z_w(i-1,j,N))
     &                 *dthetadiv_nbqdz_u(i,j,k2)
                endif
                dum_s=dthetadiv_nbqdz(i,j,k,1)
              else
                if (mod(iic,1).eq.1 .and. iif.eq.1) then
                  dthetadiv_nbqdz(i,j,k,1)=(z_r(i ,j,k)
     &                                     -z_r(i-1,j,k))
     &             *2.D0*dthetadiv_nbqdz_u(i,j,k2)
                endif
                dum_s=dthetadiv_nbqdz(i,j,k,1)
              endif
                dum_s=dum_s
     &                -(gammau  *thetadiv_nbq(i  ,j,k)+
     &                  gammau_2*thetadiv_nbq(i+1,j,k)-
     &                  gammau  *thetadiv_nbq(i-1,j,k)-
     &                  gammau_2*thetadiv_nbq(i-2,j,k))
              dum_s=dum_s*Hzu_half_qdmu(i,j,k)
              qdmu_nbq(i,j,k)=qdmu_nbq(i,j,k) + dtnbq * (
     &                        dum_s + ru_int_nbq(i,j,k) )
              DU_nbq(i,j)=DU_nbq(i,j)+qdmu_nbq(i,j,k)
              ru_nbq(i,j,k)=dum_s/work(i,j)
            enddo
          enddo
          do j=JstrV,Jend
            do i=Istr,Iend
              if (k.gt.1.and.k.lt.N) then
                if (mod(iic,1).eq.1 .and. iif.eq.1) then
                  dthetadiv_nbqdz(i,j,k,2)=(z_r(i,j  ,k)
     &                                     -z_r(i,j-1,k))
     &                *(dthetadiv_nbqdz_v(i,j,k2)+
     &                  dthetadiv_nbqdz_v(i,j,k1))
                endif
                dum_s=dthetadiv_nbqdz(i,j,k,2)
              elseif (k.gt.1) then
                if (mod(iic,1).eq.1 .and. iif.eq.1) then
                  dthetadiv_nbqdz(i,j,k,2)=(z_r(i,j  ,k)
     &                                     -z_r(i,j-1,k))
     &                *dthetadiv_nbqdz_v(i,j,k1)
     &                +(z_w(i,j,N)-z_w(i,j-1,N))
     &                *dthetadiv_nbqdz_v(i,j,k2)
                endif
                dum_s=dthetadiv_nbqdz(i,j,k,2)
              else
                if (mod(iic,1).eq.1 .and. iif.eq.1) then
                  dthetadiv_nbqdz(i,j,k,2)=(z_r(i,j  ,k)
     &                                     -z_r(i,j-1,k))
     &                *2.D0*dthetadiv_nbqdz_v(i,j,k2)
                endif
                dum_s=dthetadiv_nbqdz(i,j,k,2)
              endif
              dum_s=dum_s
     &             -(gammau  *thetadiv_nbq(i,j  ,k)+
     &               gammau_2*thetadiv_nbq(i,j+1,k)-
     &               gammau  *thetadiv_nbq(i,j-1,k)-
     &               gammau_2*thetadiv_nbq(i,j-2,k))
              dum_s=dum_s*Hzv_half_qdmv(i,j,k)
              qdmv_nbq(i,j,k)=qdmv_nbq(i,j,k) + dtnbq * (
     &                        dum_s + rv_int_nbq(i,j,k) )
              DV_nbq(i,j)=DV_nbq(i,j)+qdmv_nbq(i,j,k)
              rv_nbq(i,j,k)=dum_s/work(i,j)
            enddo
          enddo
        endif
      enddo
      do j=Jstr,Jend
        do i=Istr,Iend
          ubar(i,j,knew)=urhs(i,j)
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          vbar(i,j,knew)=vrhs(i,j)
        enddo
      enddo
      M2bc_nbq_flag=.true.
      call u2dbc_tile   (Istr,Iend,Jstr,Jend, work)
      call v2dbc_tile   (Istr,Iend,Jstr,Jend, work)
      call unbq_bc_tile (Istr,Iend,Jstr,Jend, work)
      call vnbq_bc_tile (Istr,Iend,Jstr,Jend, work)
      call exchange_u3d_tile (Istr,Iend,Jstr,Jend,
     &                        qdmu_nbq(-2,0,1))
      call exchange_v3d_tile (Istr,Iend,Jstr,Jend,
     &                        qdmv_nbq(-2,0,1))
      if (Istr.gt.Iend) then
        do j=Jstr,Jend
          do i=Istr,Iend+1
            FX(i,j)=0.D0
          enddo
        enddo
      endif
      if (JstrV.gt.Jend) then
        do j=Jstr,Jend+1
          do i=Istr,Iend
            FY(i,j)=0.D0
          enddo
        enddo
      endif
      k2 = 1
      do k=0,N
        k1=k2
        k2=3-k1
        if (mod(iic,1).eq.1 .and. iif.eq.1) then
          if (k.lt.N) then
            kp1 = k + 1
            do j=Jstr,Jend
              do i=Istr,Iend+1
                dZdxq_u(i,j,k2)=(z_r(i,j,kp1)-z_r(i-1,j,kp1))
     &                           *qdmu_nbq(i,j,kp1)
              enddo
            enddo
          endif
          if (k.eq.0) then
          elseif (k .eq. N) then
            do j=Jstr,Jend
              do i=Istr,Iend+1
                dZdxq_w(i,j,k )= (z_w(i,j,N)-z_w(i-1,j,N))
     &                            *qdmu_nbq(i,j,N)
     &                            /(Hz(i,j,N)+Hz(i-1,j,N))
              enddo
            enddo
          else
            do j=Jstr,Jend
              do i=Istr,Iend+1
                dZdxq_w(i,j,k )=Hzw_half_nbq_inv_u(i,j,k)
     &                                 *(dZdxq_u(i,j,k1)+
     &                                   dZdxq_u(i,j,k2))
              enddo
            enddo
          endif
        else
          if (k.eq.0) then
          endif
        endif
        if (k.gt.0) then
          if (Istr.le.Iend) then
            do j=Jstr,Jend
              do i=Istr,Iend+1
                FX(i,j)=-pm_u(i,j)*(dZdxq_w(i,j,k )-dZdxq_w(i,j,k-1))
              enddo
            enddo
            do j=Jstr,Jend
              do i=Istr,Iend
                thetadiv_nbq(i,j,k)=FX(i,j)+FX(i+1,j)
              enddo
            enddo
          else
            do j=Jstr,Jend
              do i=Istr,Iend
                thetadiv_nbq(i,j,k)=0.D0
              enddo
            enddo
          endif
        endif
      enddo
      k2 = 1
      do k=0,N
        k1=k2
        k2=3-k1
        if (mod(iic,1).eq.1 .and. iif.eq.1) then
          if (k.lt.N) then
            kp1 = k + 1
            do j=Jstr,Jend+1
              do i=Istr,Iend
                dZdyq_v(i,j,k2)=(z_r(i,j,kp1)-z_r(i,j-1,kp1))
     &                           *qdmv_nbq(i,j,kp1)
              enddo
            enddo
          endif
          if (k.eq.0) then
          elseif (k .eq. N) then
            do j=Jstr,Jend+1
              do i=Istr,Iend
                dZdyq_w(i,j,k )= (z_w(i,j,N)-z_w(i,j-1,N))
     &                           *qdmv_nbq(i,j,N)
     &                           /(Hz(i,j,N)+Hz(i,j-1,N))
              enddo
            enddo
          else
            do j=Jstr,Jend+1
              do i=Istr,Iend
                dZdyq_w(i,j,k )=Hzw_half_nbq_inv_v(i,j,k)
     &                           *(dZdyq_v(i,j,k1)+
     &                             dZdyq_v(i,j,k2))
              enddo
            enddo
          endif
        else
          if (k.eq.0) then
         endif
        endif
        if (k.gt.0) then
          if (JstrV.le.Jend) then
            do j=Jstr,Jend+1
              do i=Istr,Iend
                FY(i,j)=-pn_v(i,j)*(dZdyq_w(i,j,k)-dZdyq_w(i,j,k-1))
              enddo
            enddo
            do j=Jstr,Jend
              do i=Istr,Iend
                thetadiv_nbq(i,j,k)=thetadiv_nbq(i,j,k)
     &                               +FY(i,j)+FY(i,j+1)
              enddo
            enddo
          endif
        endif
      enddo
      do k=1,N
        if (Istr.le.Iend) then
          do j=Jstr,Jend
            do i=Istr,Iend+1
              FX(i,j)=on_u(i,j)*qdmu_nbq(i,j,k)
            enddo
          enddo
        endif
        if (JstrV.le.Jend) then
          do j=Jstr,Jend+1
            do i=Istr,Iend
              FY(i,j)=om_v(i,j)*qdmv_nbq(i,j,k)
            enddo
          enddo
        endif
        if (Istr.gt.Iend) then
          do j=Jstr,Jend
            do i=Istr,Iend
              thetadiv_nbq(i,j,k)=thetadiv_nbq(i,j,k)
     &                           +pm(i,j)*pn(i,j)*(FY(i,j+1)-FY(i,j))
            enddo
          enddo
        elseif (JstrV.gt.Jend) then
          do j=Jstr,Jend
            do i=Istr,Iend
              thetadiv_nbq(i,j,k)=thetadiv_nbq(i,j,k)
     &                            +pm(i,j)*pn(i,j)*(FX(i+1,j)-FX(i,j))
            enddo
          enddo
        else
          do j=Jstr,Jend
            do i=Istr,Iend
              thetadiv_nbq(i,j,k)=thetadiv_nbq(i,j,k)
     &                            +pm(i,j)*pn(i,j)*(FX(i+1,j)-FX(i,j)+
     &                                              FY(i,j+1)-FY(i,j))
            enddo
          enddo
        endif
      enddo
       if (iif.eq.1) then
        do j=JstrR,JendR
          do k=0,N
            do i=IstrR,IendR
              zw_nbq(i,j,k,knew)=z_w(i,j,k)
            enddo
          enddo
        enddo
        do j=Jstr,Jend
          do i=Istr,Iend
            FC(i,0)=0.D0
            CF(i,0)=0.D0
          enddo
          do k=1,N-1
            do i=Istr,Iend
              FC(i,k)=
     &          -(zw_nbq(i,j,k,knew)-zw_nbq(i,j,k,kstp))/dtgrid_nbq
     &           *0.5D0*( (1.D0+rho_grd(i,j,k  ))
     &                  +rho_nbq(i,j,k  )*Hzr_half_nbq_inv(i,j,k  )
     &                  +(1.D0+rho_grd(i,j,k+1))
     &                  +rho_nbq(i,j,k+1)*Hzr_half_nbq_inv(i,j,k+1))
              CF(i,k)=
     &          -(zw_nbq(i,j,k,knew)-zw_nbq(i,j,k,kstp))/dtgrid_nbq
     &          *0.5D0*(    rho_grd(i,j,k  )
     &                   +rho_nbq(i,j,k  )*Hzr_half_nbq_inv(i,j,k  )
     &                   +rho_grd(i,j,k+1)
     &                   +rho_nbq(i,j,k+1)*Hzr_half_nbq_inv(i,j,k+1) )
              thetadiv3_nbq(i,j,k)=CF(i,k)-CF(i,k-1)
              thetadiv2_nbq(i,j,k)=FC(i,k)-FC(i,k-1)
            enddo
          enddo
           do i=Istr,Iend
             FC(i,N)=
     &        -(zw_nbq(i,j,N,knew)-zw_nbq(i,j,N,kstp))/dtgrid_nbq
     &         *( 1.D0+rho_grd(i,j,N)
     &          )
            CF(i,N)=
     &        -(zw_nbq(i,j,N,knew)-zw_nbq(i,j,N,kstp))/dtgrid_nbq
     &         *( rho_grd(i,j,N)
     &          )
            thetadiv3_nbq(i,j,N)=CF(i,N)-CF(i,N-1)
            thetadiv2_nbq(i,j,N)=FC(i,N)-FC(i,N-1)
          enddo
        enddo
       endif
      do k=0,N
        do j=Jstr,Jend
          do i=Istr,Iend
            qdmw_nbq_old(i,j,k)=qdmw_nbq(i,j,k)
          enddo
        enddo
      enddo
      do j=Jstr,Jend
        do k=1,N
          do i=Istr,Iend
            FC(i,k)= soundspeed2_nbq(i,j)*rho_nbq(i,j,k)
     &              -(thetaimp_nbq*soundspeed2_nbq(i,j)*dtnbq+visc2_nbq)
     &                       *(thetadiv_nbq(i,j,k)+thetadiv3_nbq(i,j,k))
            FC(i,k)=FC(i,k)*Hzr_half_nbq_inv(i,j,k)
          enddo
        enddo
        do k=1,N-1
          do i=Istr,Iend
            dum_s = FC(i,k) - FC(i,k+1)
            qdmw_nbq(i,j,k) = qdmw_nbq(i,j,k)
     &                        + dtnbq * ( dum_s + rw_int_nbq(i,j,k) )
          enddo
        enddo
        k=N
        do i=Istr,Iend
          dum_s =   FC(i,k)
          qdmw_nbq(i,j,k) = qdmw_nbq(i,j,k)
     &                      + dtnbq * ( dum_s + rw_int_nbq(i,j,k) )
        enddo
      enddo
      do j=Jstr,Jend
        k=1
        do i=Istr,Iend
          cff1=1.D0/(dtnbq*(thetaimp_nbq**2*soundspeed2_nbq(i,j)
     &            *dtnbq+visc2_nbq))
          cff=(cff1+Hzw_half_nbq_inv(i,j,1)*(Hzr_half_nbq_inv(i,j,1)
     &             +Hzr_half_nbq_inv(i,j,2)))
          CF(i,1)=(-Hzw_half_nbq_inv(i,j,2)*Hzr_half_nbq_inv(i,j,2))
     &                                                          /cff
          DC(i,1)=qdmw_nbq(i,j,1)*cff1/cff
     &           +qdmw_nbq(i,j,0)/cff*Hzw_half_nbq_inv(i,j,0)
     &                               *Hzr_half_nbq_inv(i,j,1)
        enddo
        do k=2,N-1
          do i=Istr,Iend
            cff1=1.D0/(dtnbq*(thetaimp_nbq**2*soundspeed2_nbq(i,j)
     &              *dtnbq+visc2_nbq))
            cff=(cff1+
     &               Hzw_half_nbq_inv(i,j,k)*(Hzr_half_nbq_inv(i,j,k)
     &              +Hzr_half_nbq_inv(i,j,k+1))
     &              +Hzw_half_nbq_inv(i,j,k-1)*Hzr_half_nbq_inv(i,j,k)
     &              *CF(i,k-1))
            CF(i,k)=(-Hzw_half_nbq_inv(i,j,k+1)
     &               *Hzr_half_nbq_inv(i,j,k+1))/cff
            DC(i,k)=(qdmw_nbq(i,j,k)*cff1+Hzw_half_nbq_inv(i,j,k-1)
     &               *Hzr_half_nbq_inv(i,j,k)*DC(i,k-1)) /cff
          enddo
        enddo
        k=N
        do i=Istr,Iend
          cff1=1.D0/(dtnbq*(thetaimp_nbq**2*soundspeed2_nbq(i,j)
     &            *dtnbq+visc2_nbq))
          cff=(cff1+Hzw_half_nbq_inv(i,j,N)*Hzr_half_nbq_inv(i,j,N)
     &             +Hzw_half_nbq_inv(i,j,N-1)
     &             *Hzr_half_nbq_inv(i,j,N)*CF(i,N-1))
          CF(i,N)=0.D0
          DC(i,k)=(qdmw_nbq(i,j,N)*cff1+Hzw_half_nbq_inv(i,j,N-1)
     &             *Hzr_half_nbq_inv(i,j,N)*DC(i,N-1))/cff
        enddo
        do i=Istr,Iend
          qdmw_nbq(i,j,N)=DC(i,k)
        enddo
        do k=N-1,1,-1
          do i=Istr,Iend
            qdmw_nbq(i,j,k)=DC(i,k)-CF(i,k)*qdmw_nbq(i,j,k+1)
          enddo
        enddo
      enddo
      do j=Jstr,Jend
        do i=Istr,Iend
          FC(i,0)=0.D0
        enddo
        do k=1,N-1
          do i=Istr,Iend
            FC(i,k)=Hzw_half_nbq_inv(i,j,k) *
     &              (thetaimp_nbq*qdmw_nbq(i,j,k)
     &              +(1.D0-thetaimp_nbq)*qdmw_nbq_old(i,j,k))
            thetadiv_nbq(i,j,k)=thetadiv_nbq(i,j,k)
     &                         +FC(i,k)-FC(i,k-1)
          enddo
        enddo
        do i=Istr,Iend
          FC(i,N)=Hzw_half_nbq_inv(i,j,N) *
     &            (thetaimp_nbq*qdmw_nbq(i,j,N)
     &           +(1.D0-thetaimp_nbq)*qdmw_nbq_old(i,j,N))
          thetadiv_nbq(i,j,N)=thetadiv_nbq(i,j,N)
     &                        +FC(i,N)-FC(i,N-1)
        enddo
      enddo
      call exchange_r3d_tile (Istr,Iend,Jstr,Jend,
     &                        thetadiv_nbq(-2,0,1))
      call exchange_r3d_tile (Istr,Iend,Jstr,Jend,
     &                        thetadiv2_nbq(-2,0,1))
      call exchange_r3d_tile (Istr,Iend,Jstr,Jend,
     &                        thetadiv3_nbq(-2,0,1))
      do k=1,N
        do j=JstrV-2,Jend+1
          do i=Istr-2,Iend+1
            rho_nbq(i,j,k) = rho_nbq(i,j,k)
     &                       - dtfast*(thetadiv_nbq(i,j,k)+
     &                                 thetadiv3_nbq(i,j,k))
          enddo
        enddo
      enddo
      call rnbq_bc_tile(Istr,Iend,Jstr,Jend, work)
      do j=JstrV-1,Jend
        do i=Istr-1,Iend
          Dnew(i,j)=(zeta(i,j,knew)+h(i,j))
        enddo
      enddo
      if (iif.eq.nfast) then
        do k=0,N
          do j=Jstr,Jend
            do i=Istr,Iend
              rw_nbq(i,j,k)=((qdmw_nbq(i,j,k)-rw_nbq(i,j,k))
     &                              /dtnbq-ndtnbq*rw_int_nbq(i,j,k))
     &                                            /(pm(i,j)*pn(i,j))
            enddo
          enddo
        enddo
      endif
      if (iif.eq.nfast) then
        do k=1,N
          do j=Jstr,Jend
            do i=Istr,Iend
              ru_int_nbq(i,j,k) = ru_int_nbq(i,j,k)
     &                      -ru_ext_nbq_old(i,j)*(Hz(i-1,j,k)+Hz(i,j,k))
              ru_nbq_avg2(i,j,k)=
     &                          ((qdmu_nbq(i,j,k)-ru_nbq_avg2(i,j,k))/dt
     &                   -ru_int_nbq(i,j,k)-(ru_ext_nbq_sum(i,j)/nfast)*
     &                      (Hz(i,j,k)+Hz(i-1,j,k)))*on_u(i,j)*om_u(i,j)
            enddo
          enddo
        enddo
        do k=1,N
          do j=JstrV,Jend
            do i=Istr,Iend
              rv_int_nbq(i,j,k) = rv_int_nbq(i,j,k)
     &                      -rv_ext_nbq_old(i,j)*(Hz(i,j-1,k)+Hz(i,j,k))
              rv_nbq_avg2(i,j,k)=
     &                          ((qdmv_nbq(i,j,k)-rv_nbq_avg2(i,j,k))/dt
     &                   -rv_int_nbq(i,j,k)-(rv_ext_nbq_sum(i,j)/nfast)*
     &                      (Hz(i,j,k)+Hz(i,j-1,k)))*on_v(i,j)*om_v(i,j)
            enddo
          enddo
        enddo
        do k=1,N
          do j=Jstr,Jend
            do i=Istr,Iend
              rw_nbq_avg2(i,j,k)=
     &                          ((qdmw_nbq(i,j,k)-rw_nbq_avg2(i,j,k))/dt
     &                           -rw_int_nbq(i,j,k))*on_r(i,j)*om_r(i,j)
            enddo
          enddo
        enddo
      endif
      call exchange_u3d_tile (Istr,Iend,Jstr,Jend,
     &                        ru_nbq_avg2(-2,0,1))
      call exchange_v3d_tile (Istr,Iend,Jstr,Jend,
     &                        rv_nbq_avg2(-2,0,1))
      call exchange_w3d_tile (Istr,Iend,Jstr,Jend,
     &                        rw_nbq_avg2(-2,0,0))
      do j=JstrV-1,Jend
        do i=Istr-1,Iend
          DUon(i,j)=zeta(i,j,kstp)+h(i,j)
        enddo
      enddo
      cff=2*dtfast
      cff1=0.5D0*weight(1,iif)
      cff2=0.5D0*weight(2,iif)
      if (iif.eq.1) then
         DU_avg1=0.D0
         DV_avg1=0.D0
         DU_avg2=0.D0
         DV_avg2=0.D0
      endif
      do j=Jstr,Jend
        do i=Istr,Iend
          DUnew=DU_nbq(i,j) *2.D0
          ubar(i,j,knew)=DUnew/(Dnew(i,j)+Dnew(i-1,j))
          DU_avg1(i,j,nnew)=DU_avg1(i,j,nnew)
     &                             +cff1*on_u(i,j)*( DUnew
     &                                                   )
          DU_avg2(i,j)=DU_avg2(i,j)+cff2*on_u(i,j)*( DUnew
     &                                                   )
        enddo
      enddo
      do j=JstrV,Jend
        do i=Istr,Iend
          DVnew=DV_nbq(i,j) *2.D0
          vbar(i,j,knew)=DVnew/(Dnew(i,j)+Dnew(i,j-1))
          DV_avg1(i,j,nnew)=DV_avg1(i,j,nnew)
     &                              +cff1*om_v(i,j)*(DVnew
     &                                                   )
          DV_avg2(i,j)=DV_avg2(i,j)+cff2*om_v(i,j)*( DVnew
     &                                                   )
        enddo
      enddo
      M2bc_nbq_flag=.false.
      call u2dbc_tile (Istr,Iend,Jstr,Jend, work)
      call v2dbc_tile (Istr,Iend,Jstr,Jend, work)
      call exchange_u2d_tile (Istr,Iend,Jstr,Jend,
     &                        ubar(-2,0,knew))
      call exchange_v2d_tile (Istr,Iend,Jstr,Jend,
     &                        vbar(-2,0,knew))
      if (jstr.eq.1) then
        do i=Istr-1,IendR
          Dnew(i,Jstr-1)=(h(i,Jstr-1)+zeta(i,Jstr-1,knew))
        enddo
      endif
      if (jend.eq.Mm) then
        do i=Istr-1,IendR
          Dnew(i,Jend+1)=(h(i,Jend+1)+zeta(i,Jend+1,knew))
        enddo
      endif
      cff1=0.5D0*weight(1,iif)
      cff2=0.5D0*weight(2,iif)
      if (jstr.eq.1) then
        do i=Istr,Iend
          cff=(Dnew(i,Jstr-1)+Dnew(i-1,Jstr-1))*(ubar(i,Jstr-1,knew)
     &                                              )*on_u(i,Jstr-1)
          DU_avg1(i,Jstr-1,nnew)=DU_avg1(i,Jstr-1,nnew)+cff1*cff
          DU_avg2(i,Jstr-1)=DU_avg2(i,Jstr-1)+cff2*cff
        enddo
        do i=IstrR,IendR
          cff=(Dnew(i,JstrV-1)+Dnew(i,JstrV-2))*(vbar(i,JstrV-1,knew)
     &                                              )*om_v(i,JstrV-1)
          DV_avg1(i,JstrV-1,nnew)=DV_avg1(i,JstrV-1,nnew)+cff1*cff
          DV_avg2(i,JstrV-1)=DV_avg2(i,JstrV-1)+cff2*cff
        enddo
      endif
      if (jend.eq.Mm) then
        do i=Istr,Iend
          cff=(Dnew(i,Jend+1)+Dnew(i-1,Jend+1))*(ubar(i,Jend+1,knew)
     &                                              )*on_u(i,Jend+1)
          DU_avg1(i,Jend+1,nnew)=DU_avg1(i,Jend+1,nnew)+cff1*cff
          DU_avg2(i,Jend+1)=DU_avg2(i,Jend+1)+cff2*cff
        enddo
        do i=IstrR,IendR
          cff=(Dnew(i,Jend+1)+Dnew(i,Jend))*(vbar(i,Jend+1,knew)
     &                                          )*om_v(i,Jend+1)
          DV_avg1(i,Jend+1,nnew)=DV_avg1(i,Jend+1,nnew)+cff1*cff
          DV_avg2(i,Jend+1)=DV_avg2(i,Jend+1)+cff2*cff
        enddo
      endif
        do j=Jstr-1,Jend+1
          do i=Istr-1,Iend+1
            Dnew(i,j)=(zeta(i,j,knew)+h(i,j))
          enddo
        enddo
        do j=Jstr,Jend
          do i=Istr,Iend
            zeta(i,j,knew)=( (h(i,j)+zeta(i,j,kstp))
     &                                + (dtfast*pm(i,j)*pn(i,j)*0.5D0*(
     &      (Dnew(i  ,j)+Dnew(i-1,j))*(ubar(i  ,j,knew)
     &                                                 )*on_u(i  ,j)
     &     -(Dnew(i+1,j)+Dnew(i  ,j))*(ubar(i+1,j,knew)
     &                                                 )*on_u(i+1,j)
     &     +(Dnew(i,j  )+Dnew(i,j-1))*(vbar(i,j  ,knew)
     &                                                 )*om_v(i,j  )
     &     -(Dnew(i,j+1)+Dnew(i,j  ))*(vbar(i,j+1,knew)
     &                                                 )*om_v(i,j+1))) )
     &                                                          - h(i,j)
          enddo
        enddo
      call zetabc_tile (Istr,Iend,Jstr,Jend)
      if (iif.eq.nfast) then
        do j=JstrR,JendR
          do i=IstrR,IendR
            Zt_avg1(i,j)=zeta(i,j,knew)
          enddo
        enddo
      endif
      if (iif.eq.nfast) then
        call set_depth_tile(Istr,Iend,Jstr,Jend)
      endif
      call exchange_r2d_tile (Istr,Iend,Jstr,Jend,
     &                        zeta(-2,0,knew))
      call exchange_u2d_tile (Istr,Iend,Jstr,Jend,
     &                        DU_avg1(-2,0,nnew))
      call exchange_v2d_tile (Istr,Iend,Jstr,Jend,
     &                        DV_avg1(-2,0,nnew))
      call exchange_u2d_tile (Istr,Iend,Jstr,Jend,
     &                        DU_avg2(-2,0))
      call exchange_v2d_tile (Istr,Iend,Jstr,Jend,
     &                        DV_avg2(-2,0))
      if (iif.eq.nfast) then
        do k=1,N
          do j=JstrV-2,Jend+1
            do i=Istr-2,Iend+1
              Hz_correct(i,j,k)=Hz(i,j,k)
            enddo
          enddo
        enddo
        call exchange_u2d_tile (Istr,Iend,Jstr,Jend,
     &                          DU_avg2(-2,0))
        call exchange_v2d_tile (Istr,Iend,Jstr,Jend,
     &                          DV_avg2(-2,0))
        do j=Jstr,Jend
          do i=Istr,Iend
            dum_s=0.D0
            do k=1,N
              dum_s=dum_s+Hz(i,j,k)-Hz_bak(i,j,k)
            enddo
            do k=1,N
              Hz(i,j,k)=Hz(i,j,k)
     &                -(dum_s
     &             + (DU_avg2(i+1,j)-DU_avg2(i,j)
     &               +DV_avg2(i,j+1)-DV_avg2(i,j)
     &               )*pm(i,j)*pn(i,j)
     &               *dt)
     &               /(z_w(i,j,N)-z_w(i,j,0))
     &               *(z_w(i,j,k)-z_w(i,j,k-1))
            enddo
          enddo
        enddo
        call exchange_r3d_tile (Istr,Iend,Jstr,Jend,
     &                          Hz(-2,0,1))
      endif
      VMAXL=100.D0
      VMAX=0.D0
      do j=Jstr,Jend
        do i=Istr,Iend
          cff1=ubar(i,j,knew)
          cff2=vbar(i,j,knew)
          cff=max(abs(cff1),abs(cff2))
          IF (cff.GE.VMAX .or. cff1.ne.cff1 .or. cff2.ne.cff2) THEN
            IF (cff.GE.VMAX .and. cff1.eq.cff1 .and. cff2.eq.cff2) THEN
              VMAX=cff
            ELSE
              VMAX=666.D0
            ENDIF
            imax=i
            jmax=j
          ENDIF
        enddo
      enddo
      IF (VMAX.GT.VMAXL) THEN
        write(stdout,'(9(A/))')
     &     '                                         ',
     &     '                                         ',
     &     ' ======================================= ',
     &     ' =                                     = ',
     &     ' =  STEP3D_FAST:   ABNORMAL JOB END    = ',
     &     ' =                 BLOW UP             = ',
     &     ' =                                     = ',
     &     ' ======================================= ',
     &     '                                         '
        if (VMAX.eq.666.D0) then
          write(stdout,'(A,F10.2)')
     &                                            '  VMAX (M/S) =   NaN'
        else
          write(stdout,'(A,F10.2)')
     &                                            '  VMAX (M/S) =',VMAX
        endif
        write(stdout,'(A,2I6)')
     &                                       '  IMAX JMAX   =',imax,jmax
        write(stdout,'(A,2I6/)')
     &                                       '  IINT IFAST  =',iic,iif
        call wrt_his
        may_day_flag=1
        stop
      ENDIF
      return
      end
